function[allcentroids]=trackmovemaster5(data)
X=calim(data.calibrationimage);
xmax=X^(-1)*[0;0;1];xmax=xmax(1)
xmin=X^(-1)*[-24;0;1];xmin=xmin(1)
s=data.frames(1).frames;
fps=data.fps;
box=70;
[a b]=size(data.frames);
count=0;
limcheck=0;
vidnumber=1;


for g=[1,2,3,4,5,6,7,8]%:numel(data.frames)
    imshow(data.frames(g).frames(:,:,end))
    [w x]=ginput(1);
    xmincheck=0;
    clear centroids
    clear a
    clear xvel
    clear xvelnofilter
    clear yvel
    clear time
    s=data.frames(g).frames;
    numframes=size(s(1,1,:));
    numframes=numframes(3);
    for i = numframes:-1:2
    s(:, :, i) = imabsdiff(s(:, :, i), data.frames(g).frames(:,:,2));
    end
    thresh=graythresh(s);
     bw=(s >= thresh*140);
     
    % imshow(data.frames(1).frames(:,:,end))
    for k=numframes-1:-1:1
            if k==numframes-1
                cropped(:,:,k)=imcrop(bw(:,:,k),[w-box/2 x-box/2 box box]);
                cropped(:,:,k) = bwareaopen(cropped(:,:,k), 5, 8);
                 se=strel('disk',12);
                cropped(:,:,k)=imclose(cropped(:,:,k),se);
                L=bwlabel(cropped(:,:,k));
                s  = regionprops(L, 'centroid');
                [aa]=s.Centroid;
                a(k)=secondmoment(L,aa);
                centroids(:,k)= aa;
                centroids(1,k)=centroids(1,k)+w-box/2; %convert centroid location from cropped box to location in full image
                centroids(2,k)=centroids(2,k)+x-box/2;
                limcheck=(aa(1)+w-box/2);
            else
                cropped(:,:,k)=imcrop(bw(:,:,k),[centroids(1,k+1)-box/2 centroids(2,k+1)-box/2 box box]);
                cropped(:,:,k) = bwareaopen(cropped(:,:,k), 5, 8);
                se=strel('disk',12);
                cropped(:,:,k)=imclose(cropped(:,:,k),se);
                [L numobjects]=bwlabel(cropped(:,:,k));
                numobjects;
                s=regionprops(L,'centroid');
                
                [aa]=s.Centroid;
               a(k)=secondmoment(L,aa);
               %figure
               %imshow(L)
                if numobjects==0
                    centroids(:,k)=centroids(:,k+1);
                elseif numobjects==1
                    s  = regionprops(L, 'centroid');
                    [aa]=s.Centroid;
                   % figure
                    %imshow(cropped(:,:,k))
                    centroids(:,k)=aa;
                    centroids(1,k)=centroids(1,k)+(centroids(1,k+1)-box/2); %convert centroid location from cropped box to location in full image
                    centroids(2,k)=centroids(2,k)+(centroids(2,k+1)-box/2);
                else
                    s  = regionprops(L, 'centroid');
                    [aa bb]=s.Centroid;
                    centroids(:,k)= [(aa(1)+bb(1))/2 (aa(2)+bb(2))/2];
                   % figure
                    %imshow(cropped(:,:,k))
                    centroids(1,k)=centroids(1,k)+(centroids(1,k+1)-box/2); %convert centroid location from cropped box to location in full image
                    centroids(2,k)=centroids(2,k)+(centroids(2,k+1)-box/2);
                    
                end
                    limcheck=(aa(1)+(centroids(1,k+1)-box/2));
                    %{
                    if limcheck>xmin & xmincheck==0  %For forward motion
                        frameend=k+1;
                        xmincheck=xmincheck+1;
                    end
                    if limcheck>xmax
                        framestart=k+1;
                        break
                    end
                    %}
                    
                       
                    if limcheck<xmax & xmincheck==0 %For backwards motion
                        frameend=k+1;
                        xmincheck=xmincheck+1;
                    end
                 
                    if limcheck<xmin 
                        framestart=k+1;
                        break
                    end
                    
                      
            end


            %imshow(data.frames(g).frames(:,:,k))
            hold on 
            xorient=[centroids(1,k)+30*cosd(-a(k)),centroids(1,k)-30*cosd(-a(k))];
            yorient=[centroids(2,k)+30*sind(-a(k)),centroids(2,k)-30*sind(-a(k))];
            hold on
            plot(xorient,yorient,'r')
            plot(centroids(1,k),centroids(2,k),'w*')
            hold off

    end

numframes=frameend-framestart;
centroids=centroids(:,framestart:(frameend-1));
%{
imshow(data.frames(:,:,end))
hold on
plot(centroids(1,:),centroids(2,:),'b.')
hold on

%}
centroids(3,:)=ones(1,numframes)
for k=numframes:-1:1
    r=X*centroids(:,k);
    centroids(:,k)=r./r(3); %convert camera coordinates to world coordinates
end
time=0:1/fps:numframes/fps-1/fps;
%{
figure
plot(time,centroids(1,:));xlabel('time');ylabel('x position (mm)');%ylim([-10 10])
figure
%
figure
plot(time,centroids(2,:));xlabel('time');ylabel('y position (mm)');%ylim([-25 25])
%}
dt=1/fps;
for k=numframes-1:-1:1
    xvelnofilter(k)=(centroids(1,k+1)-centroids(1,k))/(1/fps);
    yvel(k)=(centroids(2,k+1)-centroids(2,k))/(1/fps);
end

%figure
%plot(time(1:numel(xvel)),xvel);xlabel('time');ylabel('x velocity (mm/s)')
%figure
%plot(time(1:numel(xvelnofilter)),xvelnofilter);xlabel('time');ylabel('x velocity no filter (mm/s)')
for k=framestart:frameend
        a(k)=a(k);
end
a=a(framestart:frameend-1);
allcentroids(vidnumber).centroids=centroids;
allcentroids(vidnumber).time=time;
allcentroids(vidnumber).orientation=a;
allcentroids(vidnumber).velocity=xvelnofilter;
allcentroids(vidnumber).xvelmean=mean(xvelnofilter);
allcentroids(vidnumber).orientationmean=mean(a);
allcentroids(vidnumber).xvelstd=std(xvelnofilter);
allcentroids(vidnumber).fps=fps;
allcentroids(vidnumber).yvelocity=yvel;
allcentroids(vidnumber).yvelmean=mean(yvel);
allcentroids(vidnumber).ay=data.platemotion.ay;
allcentroids(vidnumber).yvelstd=std(yvel);
allcentroids(vidnumber).ay=data.platemotion.ay;
allcentroids(vidnumber).ax=data.platemotion.ax;
vidnumber=vidnumber+1;
end













