function angle=secondmoment(image,centroid)
%takes as inputs the cropped centroid image along with the centroid of the
%part. outputs the orientation angle in degrees. 0 degrees corresponds to a
%horizonal line. 
[row col]=size(image);
lxx=0;
lyy=0;
lxy=0;
for x=1:col
    for y=1:row
        if image(y,x)~=0
            lxx=lxx+(centroid(1)-x)^2;
            lyy=lyy+(centroid(2)-y)^2;
            lxy=lxy+(centroid(1)-x)*(centroid(2)-y);
        end
    end
end

l= [lxx lxy;lxy lyy];
[V D]=eig(l);
angle=atand(V(1,1)/V(2,1));



